=== modified file 'libupstart-app-launch/upstart-app-launch.c'
--- libupstart-app-launch/upstart-app-launch.c	2014-01-29 20:15:51 +0000
+++ libupstart-app-launch/upstart-app-launch.c	2014-02-05 20:57:37 +0000
@@ -63,6 +63,7 @@
 	GVariant * result = NULL;
 
 	tracepoint(upstart_app_launch, libual_start_message_callback, data->appid);
+
 	g_debug("Started Message Callback: %s", data->appid);
 
 	result = g_dbus_connection_call_finish(G_DBUS_CONNECTION(obj), res, &error);
@@ -77,6 +78,8 @@
 			if (g_strcmp0(remote_error, "com.ubuntu.Upstart0_6.Error.AlreadyStarted") == 0) {
 				second_exec(data->appid, data->uris);
 			}
+
+			g_free(remote_error);
 		} else {
 			g_warning("Unable to emit event to start application: %s", error->message);
 		}
@@ -90,7 +93,7 @@
 
 /* Get the path of the job from Upstart, if we've got it already, we'll just
    use the cache of the value */
-const gchar *
+static const gchar *
 get_jobpath (GDBusConnection * con, const gchar * jobname)
 {
 	gchar * cachepath = g_strdup_printf("upstart-app-lauch-job-path-cache-%s", jobname);
@@ -133,7 +136,7 @@
 
 /* Check to see if a legacy app wants us to manage whether they're
    single instance or not */
-gboolean
+static gboolean
 legacy_single_instance (const gchar * appid)
 {
 	tracepoint(upstart_app_launch, desktop_single_start, appid);
@@ -1191,6 +1194,7 @@
 	if (uris != NULL) {
 		gchar * urisjoin = app_uris_string(uris);
 		g_variant_builder_add_value(&builder, g_variant_new_take_string(g_strdup_printf("APP_URIS=%s", urisjoin)));
+		g_free(urisjoin);
 	}
 
 	if (instance != NULL) {

=== modified file 'libupstart-app-launch/upstart-app-launch.h'
--- libupstart-app-launch/upstart-app-launch.h	2014-01-29 20:15:51 +0000
+++ libupstart-app-launch/upstart-app-launch.h	2014-02-05 15:03:15 +0000
@@ -308,7 +308,7 @@
  * Start an untrusted helper for a specific @type on a given
  * @appid.  We don't know how that is done specifically, as Upstart
  * will call a helper for that type.  And then execute it under the
- * Apparmor profile for that helper type.
+ * AppArmor profile for the helper as defined in its manifest.
  *
  * Return value: Whether the helper was able to be started
  */

=== modified file 'tests/libual-test.cc'
--- tests/libual-test.cc	2014-01-29 20:15:51 +0000
+++ tests/libual-test.cc	2014-02-05 20:54:29 +0000
@@ -245,7 +245,7 @@
 				pause(100);
 				cleartry++;
 			}
-			ASSERT_EQ(nullptr, bus);
+			ASSERT_EQ(bus, nullptr);
 		}
 
 		bool check_env (GVariant * env_array, const gchar * var, const gchar * value) {

=== modified file 'untrusted-helper-type-end.c'
--- untrusted-helper-type-end.c	2014-01-28 05:26:08 +0000
+++ untrusted-helper-type-end.c	2014-02-05 21:01:45 +0000
@@ -37,15 +37,16 @@
 	int i;
 	for (i = 0; appids[i] != NULL; i++) {
 		gchar ** instances = upstart_app_launch_list_helper_instances(type, appids[i]);
+		guint instance_cnt = g_strv_length(instances);
 
-		if (g_strv_length(instances) == 0) {
+		if (instance_cnt == 0) {
 			g_debug("Stopping %s", appids[i]);
 			if (!upstart_app_launch_stop_helper(type, appids[i])) {
 				g_warning("Unable to stop '%s'", appids[i]);
 			}
 		} else {
 			int j;
-			for (j = 0; j < g_strv_length(instances); j++) {
+			for (j = 0; j < instance_cnt; j++) {
 				g_debug("Stopping %s (%s)", appids[i], instances[j]);
 				if (!upstart_app_launch_stop_multiple_helper(type, appids[i], instances[j])) {
 					g_warning("Unable to stop '%s' instance '%s'", appids[i], instances[j]);

